/* This is the phone program, written by David Ashley
 * dash@xdr.com
 * http://www.xdr.com/dash
 * This program is released under the terms of the GPL
 */



/* $Header: /cvs/phone/phone.c,v 1.13 2000/02/02 06:19:20 dash Exp $ */

#include "phone.h"

#define SERVER "matcher.xdr.com"

#define MAXBLOCKS 14

char exitflag=0;
int talktries=0;
long nextsendtalk;
long lastdiff,latency;
int block160size;
int sndin,sndblocksize;
unsigned char sndblock1[16384],sndblock2[16384];
char username[MAXNAMESIZE];
char calling[MAXNAMESIZE];
int tryingtocall=0;
unsigned char myhash[8];
unsigned char mykey[8];

int connected=0;
int gottalk=0;

long incount,outcount;

#define WRITEFIFOMAX 64
unsigned char *writeput,*writetake,*writelimit;
int writein;
unsigned char writefifo[1024*WRITEFIFOMAX];
int loudcount;

unsigned char myip[16];
int myiplen;


long dspopentime;
long totalwritten;
long totalread;


#define PACKETSTOPACK 5
unsigned char packed[32+PACKETSTOPACK*33];
int packedin;

int havedsp=0;

opendsp()
{
int t;
int res;
int pid;


	if(havedsp) return 0;
	sndin=open("/dev/dsp",O_RDWR);
	if(sndin<0) return -1;

/*
	t=8;
	res=ioctl(sndin,SNDCTL_DSP_SAMPLESIZE,&t);
	if(res) return -2;
*/

	t=8000;
	res=ioctl(sndin,SNDCTL_DSP_SPEED,&t);
	if(res) return -3;

	t=1;
	res=ioctl(sndin,SNDCTL_DSP_CHANNELS,&t);
	if(res) return -4;


	res=ioctl(sndin,SNDCTL_DSP_GETFMTS,&t);

	if(!(t&AFMT_S16_LE))
	{
		printf("Digitizing in 8 bit mode\n");
		block160size=160;
		t=AFMT_U8;
		res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);
		if(res) return -6;
		t=0x20008;
		res=ioctl(sndin,SNDCTL_DSP_SETFRAGMENT,&t);
		if(res) return -5;
	} else
	{
		printf("Digitizing in 16 bit mode\n");
		block160size=160*2;
		t=AFMT_S16_LE;
		res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);
		if(res) return -6;
		t=0x20009;
		res=ioctl(sndin,SNDCTL_DSP_SETFRAGMENT,&t);
		if(res) return -5;
	}

//	t=0;res=ioctl(sndin,SNDCTL_DSP_SETFMT,&t);

	res=ioctl(sndin,SNDCTL_DSP_GETCAPS,&t);
	if(res) return -7;
	if(!(t&DSP_CAP_DUPLEX))
	{
		printf("Your soundcard/driver combination isn't allowing full duplex.\n");
		printf("That means you can't read from the microphone and write to\n");
		printf("the speakers at the same time.\n");
		printf("Unfortunately, this program depends on this capability.\n");
		return -8;
	}

	res=ioctl(sndin,SNDCTL_DSP_GETBLKSIZE,&sndblocksize);
	if(res) return -9;

	havedsp=1;
	read(sndin,sndblock1,sndblocksize);
	writeput=writetake=writefifo;
	writelimit=writefifo+WRITEFIFOMAX*sndblocksize;
	writein=0;
	packedin=0;

	dspopentime=gtime2();
	totalwritten=0;
	totalread=0;

	return 0;
}
tryopendsp()
{
int result;
	if(result=opendsp())
	{
		printf("Failed to open dsp, result code %d\n",result);
		exit(1);
	}
	incount=-1;
	outcount=0;
}


closedsp()
{
	if(havedsp)
	{
		close(sndin);
		havedsp=0;
	}
}


int openserver(char *mname,int port)
{
struct hostent *hostptr;
int status;
	hostptr=gethostbyname(mname);
	if(!hostptr)
	{
		hostptr=gethostbyaddr(mname,strlen(mname),AF_INET);
		if(!hostptr)
			return 0;
	}
	memset(&servername,0,sizeof(servername));
	servername.sin_family=AF_INET;
	servername.sin_port=htons(port);
	memcpy(&servername.sin_addr,hostptr->h_addr,hostptr->h_length);
	return 1;
}

void messagetoserver(unsigned char *m,int len)
{
unsigned char temp[512],*p,*p2;
int i;

	p=temp;
	*p++=CODE_CRYPT;
	memcpy(p,myhash,HASHSIZE);p+=HASHSIZE;
	p2=p;
	memcpy(p,specialkey,sizeof(specialkey));p+=sizeof(specialkey);
	memcpy(p,m,len);p+=len;
	len+=sizeof(specialkey);
	while(len&7)
	{
		*p++=0;
		++len;
	}
	i=len;
	while(--i>0)
	{
		p2[1]^=*p2;
		++p2;
	}
	encryptblock(temp+HASHSIZE+1,len,mykey);
/*
{
int i;
for(i=0;i<p-temp;++i) printf(" %02x",temp[i]);printf("\n");
}
*/
	putmsg(&servername,temp,p-temp);
}

void registerme(void)
{
int t;
	mesg[0]=CODE_IAM;
	memcpy(mesg+1,myip,4);
	t=ntohs(myname.sin_port);
	mesg[5]=t>>8;
	mesg[6]=t;
	messagetoserver(mesg,1+6);
}
void unregisterme(void)
{
int t;
	mesg[0]=CODE_IAMNOT;
	memcpy(mesg+1,myip,4);
	t=ntohs(myname.sin_port);
	mesg[5]=t>>8;
	mesg[6]=t;
	messagetoserver(mesg,1+6);
}


void sendtalk(void)
{
	if(talktries==MAXTALKTRIES)
	{
		printf("No response to TALK request after %d tries. Giving up.\n",
			talktries);
		talktries=0;
		return;
	}
	++talktries;
	mesg[0]=CODE_TALK;
	memcpy(mesg+1,username,MAXNAMESIZE);
	mesg[1+MAXNAMESIZE]=0;
	putmsg(&buddy,mesg,1+MAXNAMESIZE);
	nextsendtalk=gtime()+TALKTRYDELAY;
}

unsigned char myvisibleaddr[IPADDRSIZE];
unsigned char myvisibleport[IPPORTSIZE];


#define FOUR 0

int pack(unsigned char *out,unsigned char *in,int size)
{
int i,j;
#if FOUR
	for(j=i=0;i<size;i+=4)
		out[j++]=in[i]&0xf0 | ((in[i+2]&0xf0)>>4);
#else
	for(j=i=0;i<size;i+=2)
		out[j++]=in[i];
#endif
	return j;

}
int unpack(unsigned char *out,unsigned char *in,int size)
{
int i,j,k;
#if FOUR
	for(j=i=0;i<size;++i)
	{
		k=in[i];
		out[j++]=k&0xf0;
		out[j++]=k&0xf0;
		out[j++]=(k&0x0f)<<4;
		out[j++]=(k&0x0f)<<4;
	}
#else
	for(j=i=0;i<size;++i)
	{
		k=in[i];
		out[j++]=k;
		out[j++]=k;
	}
#endif
	return j;
}

void answer(void)
{
	gottalk=0;
	talktries=0;
	tryopendsp();
	connected=1;
}

void userprocessmsg(struct sockaddr_in *from,unsigned char *msg,int size)
{
long int i,j,k;
char name[MAXNAMESIZE+1];
char txt[64];
char txt2[64];
unsigned char publicaddr[4];
unsigned char publicport[4];
unsigned char localaddr[4];
unsigned char localport[2];

	if(size<1) return;
	if(*msg==CODE_CRYPT)
	{
		++msg;
		--size;
		if(size<sizeof(specialkey)) return;
		encryptblock(msg,size,mykey);
		i=size;
		while(--i>0)
			msg[i]^=msg[i-1];
		if(memcmp(msg,specialkey,sizeof(specialkey))) return;
		msg+=sizeof(specialkey);
		size-=sizeof(specialkey);
	}

	if(size<1) return;
	--size;
	switch(*msg++)
	{
	case CODE_ENTRY:
		if(memcmp(&servername.sin_addr.s_addr,&from->sin_addr.s_addr,IPADDRSIZE))
			break;
		if(memcmp(&servername.sin_port,&from->sin_port,IPPORTSIZE))
			break;

		if(size<STATSIZE) break;
		memcpy(publicaddr,msg,IPADDRSIZE);
		memcpy(publicport,msg+IPADDRSIZE,IPPORTSIZE);
		memcpy(localaddr,msg+IPADDRSIZE+IPPORTSIZE,IPADDRSIZE);
		memcpy(localport,msg+IPADDRSIZE*2+IPPORTSIZE,IPPORTSIZE);
		memset(name,0,sizeof(name));
		memcpy(name,msg+12,MAXNAMESIZE);
		if(!strcmp(name,username))
		{
			memcpy(myvisibleaddr,publicaddr,IPADDRSIZE);
			memcpy(myvisibleport,publicport,IPPORTSIZE);
		} else
		{
			sprintf(txt,"%d.%d.%d.%d:%d",msg[0],msg[1],msg[2],msg[3],
				(msg[4]<<8)|msg[5]);
			sprintf(txt2,"%d.%d.%d.%d:%d",localaddr[0],localaddr[1],
				localaddr[2],localaddr[3],(localport[0]<<8)|localport[1]);
			printf("%-21s Local:%-21s: %s\n",txt,txt2,name);
		}

		if(!connected && tryingtocall && !strcmp(name,calling))
		{
			if(!memcmp(publicaddr,myvisibleaddr,IPADDRSIZE))
			{
				memcpy(&buddy.sin_addr.s_addr,localaddr,IPADDRSIZE);
				memcpy(&buddy.sin_port,localport,IPPORTSIZE);
			} else
			{
				memcpy(&buddy.sin_addr.s_addr,publicaddr,IPADDRSIZE);
				memcpy(&buddy.sin_port,publicport,IPPORTSIZE);
			}
			buddy.sin_family=AF_INET;
			talktries=0;
			sendtalk();
		}
		break;
	case CODE_SOUND:
	   if(!connected)
	     {
		printf("got some sound...\n");
			if(talktries && 
				!memcmp(&from->sin_addr.s_addr,&buddy.sin_addr.s_addr,IPADDRSIZE) &&
				!memcmp(&from->sin_port,&buddy.sin_port,IPPORTSIZE))
			{
				memcpy(&buddy,from,sizeof(buddy));
				answer();
			} else
			{
				mesg[0]=CODE_BYE;
				putmsg(from,mesg,1);
				break;
			}
		}
		if(size>3)
		{
			j=(msg[0]<<16) | (msg[1]<<8) | msg[2];
			msg+=3;
			k=(msg[0]<<24) | (msg[1]<<16) | (msg[2]<<8) | msg[3];
			msg+=4;
			lastdiff=gtime2()-k;
			k=(msg[0]<<24) | (msg[1]<<16) | (msg[2]<<8) | msg[3];
			msg+=4;
			latency=lastdiff+k;

			if(j>incount)
			{
				incount=j;
				for(i=0;i<PACKETSTOPACK;++i)
				{
					unpack33to160(sndblock2,msg+i*33);
					writein+=block160size;
					j=writelimit-writeput;
					if(j>block160size) j=block160size;
					memcpy(writeput,sndblock2,j);
					writeput+=j;
					if(writeput==writelimit)
					{
						writeput=writefifo;
						if(j<block160size)
						{
							memcpy(writeput,sndblock2+j,block160size-j);
							writeput+=block160size-j;
						}
					}
				}
			} else
		     printf("Got packet with id %d, I've received up to %d\n",j,incount);
		}
		break;
	case CODE_TALK:
		if(connected) break;
		mesg[1+MAXNAMESIZE]=0;
		printf("Received TALK from %s\n",mesg+1);
		gottalk=1;
		memcpy(&buddy,from,sizeof(buddy));
		if(havedsp)
			chime();
		else
		{
			opendsp();
			chime();
			closedsp();
		}
		break;
	case CODE_BYE:
		if(!connected) break;
		if(memcmp(&buddy.sin_addr.s_addr,&from->sin_addr.s_addr,IPADDRSIZE))
			break;
		if(memcmp(&buddy.sin_port,&from->sin_port,IPPORTSIZE)) break;
		closedsp();
		connected=0;
		memset(&buddy,0,sizeof(buddy));
		printf("Disconnected, received BYE\n");
		break;
	case CODE_NAME:
		printf("  %s\n",msg);
		break;
	case CODE_UNKNOWN:
		printf("Received a CODE_UNKNOWN from the matcher, which means your\n");
		printf("email address identity is unknown to the server. Check your\n");
		printf(".phonerc file.\n");
		break;
	case CODE_EMPTY:
		printf("--Empty list--\n");
		printf("Your contact list is empty. Add names to your contact list\n");
		printf("and get them to add your name to theirs.\n");
		break;
	case CODE_INVALID:
		printf("Server claims your password is invalid. Check your .phonerc\n");
		printf("file and make sure you put in the pass line from the email\n");
		printf("you should have received.\n");
		break;
	case CODE_NOONE:
		printf("No one in your contact list is online\n");
		break;
	}
}

int iswhite(int c)
{
	return c==' ' || c=='\t' || c=='\n' || c=='\r';
}

void token(char *put,int len,char **take)
{
	while(**take && iswhite(**take)) ++(*take);
	while(**take && !iswhite(**take) && len>1)
	{
		*put++=*(*take)++;
		--len;
	}
	*put=0;
}
void report(void)
{
int t;

	if(!havedsp || !connected)
	{
		printf("Not connected to anyone\n");
		return;
	}
	t=gtime2();
	printf("%9ld: msec dsp open\n",t-dspopentime);
	printf("%9ld: msec of sound data written to dsp\n",totalwritten>>3+1);
	printf("%9ld: msec of sound data read from dsp\n",totalread>>3+1);
	printf("%9ld: outcount\n",outcount);
	printf("%9ld: incount\n",incount);
	printf("%9ld: msec latency\n",latency);
	printf("%9d: msec writein\n",writein>> (block160size==160 ? 3 : 4));
}

void dobye()
{
	if(!connected) return;
	printf("Sending BYE packet.\n");
	mesg[0]=CODE_BYE;
	putmsg(&buddy,mesg,1);
	memset(&buddy,0,sizeof(buddy));
	connected=0;
	closedsp();
}

void processtyped(char *msg,int size)
{
char com[64];
char data[64];
char *resolved;

	if(--size<0) return;
	if(size>MAXNAMESIZE) size=MAXNAMESIZE;
	msg[size]=0;
	token(com,sizeof(com),&msg);
	token(data,sizeof(data),&msg);
	tryingtocall=0;
	if(!strcmp(com,"call"))
	{
		if(connected)
		{
			printf("You're already connected. Use \"bye\" to disconnect.\n");
		} else
		{
			tryingtocall=1;
			resolved=findalias(data);
			if(!resolved) resolved=data;
			printf("Trying to call %s\n",resolved);
			strcpy(calling,resolved);
			msg[0]=CODE_CALL;
			computehash(msg+1,resolved);
			messagetoserver(msg,9);
		}
	} else if(!strcmp(com,"who"))
	{
		msg[0]=CODE_WHO;
		messagetoserver(msg,1);
	} else if(!strcmp(com,"bye"))
	{
		if(!connected)
			printf("You're not connected.\n");
		else
			dobye();
	} else if(!strcmp(com,"info"))
	{
		report();		
	} else if(!strcmp(com,"alias"))
	{
		listaliases();
	} else if(!strcmp(com,"quit"))
	{
		dobye();
		unregisterme();
		exitflag=1;
	} else if(!strcmp(com,"answer"))
	{
		if(gottalk)
			answer();
		else
			printf("You haven't received a TALK request.\n");
	} else if(!strcmp(com,"add"))
	{
		resolved=findalias(data);
		if(!resolved) resolved=data;
		printf("Trying to add %s\n",resolved);
		msg[0]=CODE_ADD;
		computehash(msg+1,resolved);
		messagetoserver(msg,9);
	} else if(!strcmp(com,"del"))
	{
		resolved=findalias(data);
		if(!resolved) resolved=data;
		printf("Trying to remove %s\n",resolved);
		msg[0]=CODE_REMOVE;
		computehash(msg+1,resolved);
		messagetoserver(msg,9);
	} else if(!strcmp(com,"list"))
	{
		msg[0]=CODE_LIST;
		messagetoserver(msg,1);
	} else
	{
		printf("Commands:\n");
		printf("add <username>     = add user to your contact list\n");
		printf("alias              = list aliases\n");
		printf("answer             = answer a TALK request\n");
		printf("bye                = disconnect call\n");
		printf("call <username>    = make call\n");
		printf("del <username>     = remove user from your contact list\n");
		printf("info               = print out some statistics\n");
		printf("list               = printout contact list\n");
		printf("quit               = quit out of program\n");
		printf("who                = query server for who in your contact list is online\n");
		printf("---\n");
	}
}

#define THRESHOLD (8<<8)
int checkloud(unsigned char *p)
{
int i,j,max,min;
	i=160;
	max=-5000;
	min=5000;
	while(i--)
	{
		j=*p++;
		j|=*p++<<8;
		if(j>=0x8000) j-=0x10000;
		if(j<min) min=j;
		if(j>max) max=j;
	}
	if(max-min>THRESHOLD) return 1;
	return 0;
}

void cchandler(int num)
{
	signal(SIGINT,SIG_IGN);
}
#define VOL 0x20
chime()
{
unsigned char buff[1024];
int i;
	if(!havedsp) return;
	if(block160size==160)
	{
		for(i=0;i<160;++i)
			if(i%40<20) buff[i]=0x80-VOL;
			else buff[i]=0x80+VOL;
	} else
	{
		for(i=0;i<160;++i)
			if(i%40<20) buff[i+i]=0,buff[i+i+1]=-VOL;
			else buff[i+i]=0,buff[i+i+1]=VOL;
	}
	for(i=0;i<8;++i)
		write(sndin,buff,block160size);
}


main(int argc,char *argv[])
{
int size,pid,result,port;
long nexttime,t;
fd_set inputs,outputs;
struct timeval timeout;
char typed[256];
int samplesin;
int i,j;
char *s;
unsigned char *p;

	cchandler(0);
	inittime();
	srand(timebase);
	myiplen=getmyip(myip);
	if(myiplen<0)
	{
		printf("Failed to determine local IP address, code %d\n",myiplen);
		return -60;
	}
	scanrcfile(0);
	if(!findalias("me"))
		addalias("me",username);
	for(i=0;i<KEYSIZE;++i)
		if(mykey[i]) break;
	if(i==KEYSIZE)
	{
		printf("WARNING:You haven't specificied your password in the PHONERC file.\n");
		printf("Pretty much nothing will work without that password. Visit the site\n");
		printf("   http://www.linuxmotors.com/phone\n");
		printf("and follow the link there to get a password assigned.\n");
	}
	computehash(myhash,username);

	havedsp=0;
	initinputcompression();
	initoutputcompression();

	i=opendsp();
	if(i)
	{
		printf("Failed to open dsp for test, code %d\n",i);
	}
	closedsp();

	if(!openserver(SERVER,PORT))
	{
		printf("Failed to resolve server %s\n",s);
		exit(2);
	}

	getsocket(0);

	exitflag=0;
	loudcount=0;
	samplesin=0;
	connected=0;
	gottalk=0;
	nexttime=gtime();
	talktries=0;
	while(!exitflag)
	{
		if(gtime()>=nexttime)
		{
			nexttime+=UPDATETIME;
			registerme();
		}
		if(talktries>0 && gtime()>=nextsendtalk)
			sendtalk();
		FD_ZERO(&inputs);
		FD_ZERO(&outputs);
		FD_SET(udpsocket,&inputs);
		FD_SET(0,&inputs);
		if(havedsp)
		{
			FD_SET(sndin,&inputs);
			if(writein>sndblocksize)
				FD_SET(sndin,&outputs);
		}
		timeout.tv_sec=1;
		timeout.tv_usec=0;
		t=select(32,&inputs,&outputs,0,&timeout);
		if(!t) continue;
		if(FD_ISSET(0,&inputs)) // typed in something
		{
			size=read(0,typed,sizeof(typed));
			if(size>0)
				processtyped(typed,size);
		}
		if(FD_ISSET(udpsocket,&inputs)) // received a packet
		{
		   size=getmsg(0);
		   if(size>0) {
//		      printf ("received control input\n");
		      userprocessmsg(&sender,mesg,size);
		   }
		}
		if(havedsp && FD_ISSET(sndin,&inputs)) // dsp data
		{
			size=read(sndin,sndblock1+samplesin,sndblocksize);
			if(connected && size>0)
			{
				totalread+=size;
				samplesin+=size;
				i=0;
				while(samplesin-i>=block160size)
				{
					loudcount+=checkloud(sndblock1+i);
					pack160to33(packed+12+packedin*33,sndblock1+i);
					i+=block160size;
					++packedin;
					if(packedin==PACKETSTOPACK)
					{
						long now;
						now=gtime2();
						packed[0]=CODE_SOUND;
						packed[1]=outcount>>16;
						packed[2]=outcount>>8;
						packed[3]=outcount;
						packed[4]=now>>24;
						packed[5]=now>>16;
						packed[6]=now>>8;
						packed[7]=now;
						packed[8]=lastdiff>>24;
						packed[9]=lastdiff>>16;
						packed[10]=lastdiff>>8;
						packed[11]=lastdiff;
						++outcount;
						putmsg(&buddy,packed,12+PACKETSTOPACK*33);

						packedin=0;
						loudcount=0;
					}
				}
				if(i)
				{
					samplesin-=i;
					memcpy(sndblock1,sndblock1+i,samplesin);
				}
			}
		}
		if(havedsp && FD_ISSET(sndin,&outputs)) //&& writein>=sndblocksize)
		{
			if(writein>=sndblocksize*(MAXBLOCKS+1))
			{
				while(writein>=sndblocksize<<1)
				{
					writein-=sndblocksize;
					writetake+=sndblocksize;
					if(writetake==writelimit)
						writetake=writefifo;
				}
			}
			write(sndin,writetake,sndblocksize);
			totalwritten+=sndblocksize;

			writein-=sndblocksize;
			writetake+=sndblocksize;
			if(writetake==writelimit)
				writetake=writefifo;

		}
	}
}
